#include<stdio.h>
#include<stdlib.h>
#include<math.h>
#include"SimpleImage.h" /* 画像クラス */
#include"BMPIO.h" /* BMP画像の入出力関数 stdlib.hが必要 */


/* BMP画像を読み込んでMinフィルタを適用しBMP画像として保存する 
コンパイル: g++ -o MinFilter MinFilter.cxx -lm
実行： ./MinFilter 入力BMP 出力BMP 畳み込み半径(int)
引数3
*/
int main(int argc,char *argv[]){
  
  
  /* 画像クラスImageを用いて入力画像のカラー用にR,G,Bを宣言する */
  Image *R = NULL;
  Image *G = NULL;
  Image *B = NULL;
  

  /* 画像サイズ */
  int sx,sy;

  
  /* BMPIOクラスを宣言しnewする */
  BMPIO *mybmp = new BMPIO();
  /* BMPIOクラスのreadBMPSize()を使って、argv[1]で与えられたファイル名でsx,syに画像サイズを入れる */
  if(mybmp->readBMPSize(&sx,&sy,argv[1])){

    /* sx,syでR,G,Bのメモリを確保する(new する) */
    R = new Image(sx,sy);
    G = new Image(sx,sy);
    B = new Image(sx,sy);

    /* BMPIOクラスのreadBMP()を使ってargv[1]で与えられるファイル名の画像をR,G,Bに読み込む */
    mybmp->readBMP(R,G,B,argv[1]);
    
  }else{
    delete mybmp;
    printf("Unsupported BMP format !\n");
    return 1;
  }
  
  
 
  
  /* 畳み込み半径をradiiへセットする */
  int radii = atoi(argv[3]);
    

  /* 出力画像用にImageクラスをoutR,outG,outBとして宣言しsx,syのサイズでメモリを確保する */
  Image *outR = new Image(sx,sy);
  Image *outG = new Image(sx,sy);
  Image *outB = new Image(sx,sy);
    
  /* Minフィルタ計算ここから */
  int i,j,l,m;
    


  /* 各画素をたどるループ */
  for(i=0;i<sy;i++)
      for(j=0;j<sx;j++){
	double minR=R->img[i][j];
	double minG=G->img[i][j];
	double minB=B->img[i][j];
	
	for(l=-radii;l<=radii;l++){
	  int li = i+l;if(li<0)li=0;if(li>sy-1)li=sy-1;
	  for(m=-radii;m<=radii;m++){
	    int mj = j+m;if(mj<0)mj=0;if(mj>sx-1)mj=sx-1;
	    if(minR>R->img[li][mj])minR=R->img[li][mj];
	    if(minG>G->img[li][mj])minG=G->img[li][mj];
	    if(minB>B->img[li][mj])minB=B->img[li][mj];
	  }
	}
	outR->img[i][j] = minR;
	outG->img[i][j] = minG;
	outB->img[i][j] = minB;
      }
  
    
  /* Minフィルタ計算ここまで */
 
  
  /* BMPIOクラスのsaveBMP()を使ってargv[2]で与えられるファイル名にoutR,outG,outBの画像を保存する */
  mybmp->saveBMP(outR,outG,outB,argv[2]);
  
  
  /* BMPIOクラスのメモリを開放する(deleteする) */
  delete mybmp;
  
  /* R,G,Bのメモリを開放する(deleteする) */
  delete R;
  delete G;
  delete B;
  
  /* outR,outG,outBのメモリを開放する(deleteする) */
  delete outR;
  delete outG;
  delete outB;
 


  return 0;
}
