// Structured Element = Circle
void Erosion(Image *in,Image *out,int radii){
  int i,j,l,m;
  int radii2=radii*radii;
  for(i=0;i<in->sy;i++)
    for(j=0;j<in->sx;j++){
      double min=in->img[i][j];
      for(l=-radii;l<=radii;l++){
	int li = i+l;if(li<0)li=0;if(li>in->sy-1)li=in->sy-1;
	for(m=-radii;m<=radii;m++){
	  int mj = j+m;if(mj<0)mj=0;if(mj>in->sx-1)mj=in->sx-1;
	  if(l*l+m*m<=radii2){
	    if(min>in->img[li][mj])min=in->img[li][mj];
	  }
	}
      }
      out->img[i][j] = min;
    }
}


void Dilation(Image *in,Image *out,int radii){
  int i,j,l,m;
  int radii2=radii*radii;
  for(i=0;i<in->sy;i++)
    for(j=0;j<in->sx;j++){
      double max=in->img[i][j];
      for(l=-radii;l<=radii;l++){
	int li = i+l;if(li<0)li=0;if(li>in->sy-1)li=in->sy-1;
	for(m=-radii;m<=radii;m++){
	  int mj = j+m;if(mj<0)mj=0;if(mj>in->sx-1)mj=in->sx-1;
	  if(l*l+m*m<=radii2){
	    if(max<in->img[li][mj])max=in->img[li][mj];
	  }
	}
      }
      out->img[i][j] = max;
    }

}

void Opening(Image *in,Image *out,int radii){
  Image *tmp = new Image(in->sx,in->sy);
  Erosion(in,tmp,radii);
  Dilation(tmp,out,radii);
  delete tmp;
}

void Closing(Image *in,Image *out,int radii){
  Image *tmp = new Image(in->sx,in->sy);
  Dilation(in,tmp,radii);
  Erosion(tmp,out,radii);
  delete tmp;
}

void TopHat(Image *in,Image *out,int radii){
  
  Opening(in,out,radii);
  int i,j;
  for(i=0;i<in->sy;i++)
    for(j=0;j<in->sx;j++){
      out->img[i][j] = in->img[i][j]-out->img[i][j];
    }
  
  
}

void BottomHat(Image *in,Image *out,int radii){
  
  Closing(in,out,radii);
  int i,j;
  for(i=0;i<in->sy;i++)
    for(j=0;j<in->sx;j++){
      out->img[i][j] = out->img[i][j]-in->img[i][j];
    }
  
}
